- NAME
- SYNOPSIS
- DESCRIPTION
- RETURN VALUES
- SEE ALSO
- HISTORY
- COPYRIGHT

# NAME

BUF_MEM_new, BUF_MEM_new_ex, BUF_MEM_free, BUF_MEM_grow, BUF_MEM_grow_clean, BUF_reverse - simple character array structure

standard C library equivalents

# SYNOPSIS

     #include <openssl/buffer.h>

     BUF_MEM *BUF_MEM_new(void);

     BUF_MEM *BUF_MEM_new_ex(unsigned long flags);

     void BUF_MEM_free(BUF_MEM *a);

     int BUF_MEM_grow(BUF_MEM *str, int len);
     size_t BUF_MEM_grow_clean(BUF_MEM *str, size_t len);

     void BUF_reverse(unsigned char *out, const unsigned char *in, size_t size);

# DESCRIPTION

The buffer library handles simple character arrays. Buffers are used for various purposes in the library, most notably memory BIOs.

BUF_MEM_new() allocates a new buffer of zero size.

BUF_MEM_new_ex() allocates a buffer with the specified flags. The flag BUF_MEM_FLAG_SECURE specifies that the data pointer should be allocated on the secure heap; see RETURN VALUES

BUF_MEM_new() returns the buffer or NULL on error.

BUF_MEM_free() has no return value.

BUF_MEM_grow() and BUF_MEM_grow_clean() return zero on error or the new size (i.e., len).

# SEE ALSO

CRYPTO_secure_malloc(3).

# HISTORY

BUF_MEM_new_ex() was added in OpenSSL 1.1.0.

# COPYRIGHT

Copyright 2000-2016 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the OpenSSL license (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at https://www.openssl.org/source/license.html.